<template>
  <div style="width: 100%; height: 100%">
    <el-upload
      :action="uploadUrl"
      :before-upload="handleBeforeUpload"
      :on-success="handleUploadSuccess"
      :on-error="handleUploadError"
      name="file"
      :show-file-list="false"
      :headers="headers"
      style="display: none"
      ref="upload"
      v-if="this.type == 'url'"
    >
    </el-upload>
    <!-- 编辑器 -->
    <div class="editor" ref="editor" :style="styles"></div>

    <!--视频上传-->
    <div>
      <el-dialog
        :close-on-click-modal="false"
        width="50%"
        style="margin-top: 1px"
        title="视频上传"
        :visible.sync="videoDialog.show"
        append-to-body
      >
        <el-tabs v-model="videoDialog.activeName">
          <!-- <el-tab-pane label="添加视频链接" name="first">
            <el-input
              v-model="videoDialog.videoLink"
              placeholder="请输入视频链接"
              clearable
            ></el-input>
            <el-button
              type="primary"
              size="small"
              style="margin: 20px 0px 0px 0px"
              @click="addVideoLink(videoDialog.videoLink)"
              >添加
            </el-button>
          </el-tab-pane> -->
          <el-tab-pane label="本地视频上传" name="second">
            <el-upload
              ref="uploadVideo"
              v-loading="loading"
              style="text-align: center"
              drag
              :action="uploadVideoConfig.uploadUrl"
              :headers="headers"
              accept="video/*"
              :before-upload="onBeforeUploadVideo"
              :name="uploadVideoConfig.name"
              :on-success="onSuccessVideo"
              :on-error="onErrorVideo"
              :multiple="false"
            >
              <i class="el-icon-upload"></i>
              <div class="el-upload__text">
                将文件拖到此处，或<em>点击上传</em>
              </div>
              <div class="el-upload__tip" slot="tip">
                只能上传MP4文件，且不超过{{ uploadVideoConfig.maxSize }}M
              </div>
            </el-upload>
          </el-tab-pane>
        </el-tabs>
      </el-dialog>
    </div>
  </div>
</template>

<script>
import Quill from "quill";
import "quill/dist/quill.core.css";
import "quill/dist/quill.snow.css";
import "quill/dist/quill.bubble.css";
import { getToken } from "@/utils/auth";
import Video from "../../utils/hvideo";
Quill.register(Video, true);
// 工具栏
const toolbarOptions = [
  // ["bold", "italic", "underline", "strike"],       // 加粗 斜体 下划线 删除线
  // ["blockquote", "code-block"],                    // 引用  代码块
  // [{ list: "ordered" }, { list: "bullet" }], // 有序、无序列表
  [{ indent: "-1" }, { indent: "+1" }], // 缩进
  [{ size: ["small", false, "large", "huge"] }], // 字体大小
  // [{ header: [1, 2, 3, 4, 5, 6, false] }],         // 标题
  [{ color: [] }, { background: [] }], // 字体颜色、字体背景颜色
  [{ align: [] }], // 对齐方式
  ["clean"], // 清除文本格式
  // ["link", "image", "video"]                       // 链接、图片、视频
  ["image", "video"],
];
export default {
  name: "Editor",
  props: {
    /* 编辑器的内容 */
    value: {
      type: String,
      default: "",
    },
    /* 高度 */
    height: {
      type: Number,
      default: null,
    },
    /* 最小高度 */
    minHeight: {
      type: Number,
      default: null,
    },
    /* 只读 */
    readOnly: {
      type: Boolean,
      default: false,
    },
    // 上传文件大小限制(MB)
    fileSize: {
      type: Number,
      default: 10,
    },
    /* 类型（base64格式、url格式） */
    type: {
      type: String,
      default: "url",
    },
    uploadVideoConfig: {
      // 视频上传配置
      type: Object,
      default() {
        return {
          uploadUrl: process.env.VUE_APP_BASE_API + "/mudu/common/upload", // 上传地址
          maxSize: 10, // 图片上传大小限制，默认不超过2M
          name: "file", // 图片上传字段
        };
      },
    },
  },
  data() {
    let _this = this;
    return {
      uploadUrl: process.env.VUE_APP_BASE_API + "/mudu/common/upload", // 上传的图片服务器地址
      headers: {
        Authorization: "Bearer " + getToken(),
      },
      Quill: null,
      currentValue: "",
      options: {
        theme: "snow",
        bounds: document.body,
        debug: "warn",
        modules: {
          // 工具栏配置
          toolbar: {
            container: toolbarOptions, // 工具栏
            handlers: {
              video: function (value) {
                _this.videoDialog.show = true;
              },
            },
          },
          // clipboard: {
          //   // 粘贴板，处理粘贴时候的自带样式
          //   matchers: [[Node.ELEMENT_NODE, this.handleCustomMatcher]],
          // },
        },
        placeholder: "请输入内容",
        readOnly: this.readOnly,
      },
      loading: false, // 加载loading
      // 视频上传变量
      videoDialog: {
        show: false,
        videoLink: "",
        activeName: "second",
      },
      rangeing: null,
    };
  },
  computed: {
    styles() {
      let style = {};
      if (this.minHeight) {
        style.minHeight = `${this.minHeight}px`;
      }
      if (this.height) {
        style.height = `${this.height}px`;
      }
      return style;
    },
  },
  watch: {
    value: {
      handler(val) {
        if (val !== this.currentValue) {
          this.currentValue = val === null ? "" : val;
          if (this.Quill) {
            this.Quill.pasteHTML(this.currentValue);
          }
        }
      },
      immediate: true,
    },
  },
  mounted() {
    this.init();
  },
  beforeDestroy() {
    this.Quill = null;
  },
  methods: {
    // 修复粘贴回滚第一行
    findEditorScrollContainer(quill) {
      let el = quill.root;
      // console.log(el.scrollTop);
      while (el) {
        if (el.scrollTop > 0) {
          break;
        }
        el = el.parentElement;
      }
      return el;
    },
    init() {
      let _this = this;
      const editor = this.$refs.editor;
      this.Quill = new Quill(editor, this.options);
      // 如果设置了上传地址则自定义图片上传事件
      if (this.type == "url") {
        let toolbar = this.Quill.getModule("toolbar");
        toolbar.addHandler("image", (value) => {
          this.uploadType = "image";
          if (value) {
            this.$refs.upload.$children[0].$refs.input.click();
          } else {
            this.quill.format("image", false);
          }
        });
      }
      this.Quill.pasteHTML(this.currentValue);
      this.Quill.on("text-change", (delta, oldDelta, source) => {
        const html = this.$refs.editor.children[0].innerHTML;
        const text = this.Quill.getText();
        const quill = this.Quill;
        this.currentValue = html;
        if ((_this.rangeing = this.Quill.getSelection())) {
          _this.rangeing = this.Quill.getSelection().index;
        }
        this.$emit("input", html);
        this.$emit("on-change", { html, text, quill });
      });
      this.Quill.on("text-change", (delta, oldDelta, source) => {
        this.$emit("on-text-change", delta, oldDelta, source);
      });
      this.Quill.on("selection-change", (range, oldRange, source) => {
        if (range) {
          _this.rangeing = range.index;
        }
        this.$emit("on-selection-change", range, oldRange, source);
      });
      this.Quill.on("editor-change", (eventName, ...args) => {
        this.Quill.scrollingContainer = this.findEditorScrollContainer(
          this.Quill
        );
        this.$emit("on-editor-change", eventName, ...args);
      });
    },
    // 上传前校检格式和大小
    handleBeforeUpload(file) {
      // 校检文件大小
      if (this.fileSize) {
        const isLt = file.size / 1024 / 1024 < this.fileSize;
        if (!isLt) {
          this.$message.error(`上传文件大小不能超过 ${this.fileSize} MB!`);
          return false;
        }
      }
      return true;
    },
    handleUploadSuccess(res, file) {
      // 获取富文本组件实例
      let quill = this.Quill;
      // 如果上传成功
      if (res.code == 200) {
        // 获取光标所在位置
        let length = quill.getSelection().index;
        // 插入图片  res.url为服务器返回的图片地址
        quill.insertEmbed(
          length,
          "image",
          process.env.VUE_APP_BASE_API + res.fileName
        );
        // 调整光标到最后
        quill.setSelection(length + 1);
      } else {
        this.$message.error("图片插入失败");
      }
    },
    handleUploadError() {
      this.$message.error("图片插入失败");
    },
    // 保留图片跟空格，清除其余所有样式
    handleCustomMatcher(node, delta) {
      delta.ops = delta.ops.map((op) => {
        return {
          insert: op.insert,
        };
      });
      return delta;
    },
    hideLoading() {
      this.loading = false;
    },
    // --------- 视频上传相关 start ---------
    addVideoLink(videoLink) {
      let _this = this;
      if (!videoLink) return this.$message.error("请输入视频地址");
      this.videoDialog.show = false;

      let range = this.Quill.selection.savedRange.index;
      let index = 0;
      // console.log(_this.rangeing);
      if (range == null) {
        index = 0;
      } else if (_this.rangeing != null) {
        index = _this.rangeing;
      } else {
        index = range.index;
      }
      //在视频之前插入p标签
      this.Quill.insertEmbed(index, "block", "<p><br></p>");
      // 插入
      this.Quill.insertEmbed(index + 1, "video", videoLink);
      // 调整光标到最后
      this.Quill.setSelection(index + 1);
      // 上传成功，清空上传数组
      this.$refs.uploadVideo.clearFiles();
    },

    // el-文件上传组件
    onBeforeUploadVideo(file) {
      this.loading = true;
      let acceptArr = ["video/mp4"];
      const isVideo = acceptArr.includes(file.type);
      const isLt1M = file.size / 1024 / 1024 < this.uploadVideoConfig.maxSize;
      if (!isVideo) {
        this.hideLoading();
        this.$message.error("只能上传mp4格式文件!");
      }
      if (!isLt1M) {
        this.hideLoading();
        this.$message.error(
          `上传文件大小不能超过 ${this.uploadVideoConfig.maxSize}MB!`
        );
      }
      return isLt1M && isVideo;
    },
    // 文件上传成功时的钩子
    onSuccessVideo(response, file, fileList) {
      // ---- 注意这部分需要改为对应的返回格式
      this.hideLoading();
      if (response.msg === "操作成功") {
        this.addVideoLink(response.url);
      } else {
        this.$message.error("上传失败");
      }
    },
    // 文件上传失败时的钩子
    onErrorVideo(file, fileList) {
      this.hideLoading();
      this.$message.error("上传失败");
    },
    // --------- 视频上传相关 end ---------
  },
};
</script>

<style>
.editor,
.ql-toolbar {
  white-space: pre-wrap !important;
  line-height: normal !important;
}
.quill-img {
  display: none;
}
.ql-snow .ql-tooltip[data-mode="link"]::before {
  content: "请输入链接地址:";
}
.ql-snow .ql-tooltip.ql-editing a.ql-action::after {
  border-right: 0px;
  content: "保存";
  padding-right: 0px;
}

.ql-snow .ql-tooltip[data-mode="video"]::before {
  content: "请输入视频地址:";
}

.ql-snow .ql-picker.ql-size .ql-picker-label::before,
.ql-snow .ql-picker.ql-size .ql-picker-item::before {
  content: "14px";
}
.ql-snow .ql-picker.ql-size .ql-picker-label[data-value="small"]::before,
.ql-snow .ql-picker.ql-size .ql-picker-item[data-value="small"]::before {
  content: "10px";
}
.ql-snow .ql-picker.ql-size .ql-picker-label[data-value="large"]::before,
.ql-snow .ql-picker.ql-size .ql-picker-item[data-value="large"]::before {
  content: "18px";
}
.ql-snow .ql-picker.ql-size .ql-picker-label[data-value="huge"]::before,
.ql-snow .ql-picker.ql-size .ql-picker-item[data-value="huge"]::before {
  content: "32px";
}

.ql-snow .ql-picker.ql-header .ql-picker-label::before,
.ql-snow .ql-picker.ql-header .ql-picker-item::before {
  content: "文本";
}
.ql-snow .ql-picker.ql-header .ql-picker-label[data-value="1"]::before,
.ql-snow .ql-picker.ql-header .ql-picker-item[data-value="1"]::before {
  content: "标题1";
}
.ql-snow .ql-picker.ql-header .ql-picker-label[data-value="2"]::before,
.ql-snow .ql-picker.ql-header .ql-picker-item[data-value="2"]::before {
  content: "标题2";
}
.ql-snow .ql-picker.ql-header .ql-picker-label[data-value="3"]::before,
.ql-snow .ql-picker.ql-header .ql-picker-item[data-value="3"]::before {
  content: "标题3";
}
.ql-snow .ql-picker.ql-header .ql-picker-label[data-value="4"]::before,
.ql-snow .ql-picker.ql-header .ql-picker-item[data-value="4"]::before {
  content: "标题4";
}
.ql-snow .ql-picker.ql-header .ql-picker-label[data-value="5"]::before,
.ql-snow .ql-picker.ql-header .ql-picker-item[data-value="5"]::before {
  content: "标题5";
}
.ql-snow .ql-picker.ql-header .ql-picker-label[data-value="6"]::before,
.ql-snow .ql-picker.ql-header .ql-picker-item[data-value="6"]::before {
  content: "标题6";
}

.ql-snow .ql-picker.ql-font .ql-picker-label::before,
.ql-snow .ql-picker.ql-font .ql-picker-item::before {
  content: "标准字体";
}
.ql-snow .ql-picker.ql-font .ql-picker-label[data-value="serif"]::before,
.ql-snow .ql-picker.ql-font .ql-picker-item[data-value="serif"]::before {
  content: "衬线字体";
}
.ql-snow .ql-picker.ql-font .ql-picker-label[data-value="monospace"]::before,
.ql-snow .ql-picker.ql-font .ql-picker-item[data-value="monospace"]::before {
  content: "等宽字体";
}
</style>
